SystemOrganization addCategory: #'Phantom-Examples'!
SystemOrganization addCategory: #'Phantom-Examples-Telecom'!

PhAspect subclass: #ClonablePointDemoAspect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples'!

!ClonablePointDemoAspect methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 19:04'!
initialize
	super initialize.
	self add:  ((PhAdvice new)
					pointcut: ((PhPointcut new)
						receivers: 'PhantomDemoPoint';
						selectors: 'postCopy';
						context: #(#receiver));
					advice: [ :context | 
						context receiver makeRectangular.
						context receiver makePolar ];
					type: #before)! !

PhAspect subclass: #ComparablePointDemoAspect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples'!

!ComparablePointDemoAspect methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 19:04'!
initialize
	super initialize.
	self add: ((PhAdvice new)
			pointcut: ((PhPointcut new)
				receivers: 'PhantomDemoPoint';
				selectors: 'doesNotUnderstand:';
				context: #(#receiver #arguments));
			advice: [ :context | 
					(context arguments at: 1) selector = #compareTo:
						ifTrue: [ context receiver rho - ((context arguments at: 1) arguments at: 1) rho ] ];
			type: #around)! !

PhAspect subclass: #HashablePointDemoAspect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples'!

!HashablePointDemoAspect methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/2/2011 00:38'!
hash: aContext
	^((aContext receiver x + aContext receiver y) \\ SmallInteger maxVal)! !

!HashablePointDemoAspect methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 19:04'!
initialize
	super initialize.
	self
		add:
			((PhAdvice new)
				pointcut:
						((PhPointcut new)
								receivers: 'PhantomDemoPoint';
								selectors: 'hash';
								context: #(#receiver));
				advice: (Array with: self with: #hash:);
				type: #around).
	self
		add:
			((PhAdvice new)
				pointcut:
						((PhPointcut new)
								receivers: 'PhantomDemoPoint';
								selectors: '=';
								context: #(#receiver #arguments));
				advice: [ :context | (context receiver x = (context arguments at: 1) x & (context receiver y = (context arguments at: 1) y)) ];
				type: #around)! !

PhAspect subclass: #PhTelecomAspectBilling
	instanceVariableNames: 'localChargeRate longDistanceChargeRate'
	classVariableNames: 'Asp'
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomAspectBilling methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/13/2011 23:14'!
initialize
	super initialize.
	localChargeRate := 3.
	longDistanceChargeRate := 10.
	self precedence: #('PhTelecomAspectBilling' 'PhTelecomAspectTiming').
	self add: (PhAdvice new
		pointcut: PhTelecomAspectTiming endTimingPointcut;
		advice: [:context |
			| time rate cost |
			time := context receiver timer getTime.
			rate := context receiver callRate.
			cost := rate * time.
			context receiver caller addCharge: cost];
		type: #after).
	self addClassModifier: (PhClassModifier new
		on: PhTelecomCustomer;
		addNewInstanceVar: 'totalCharge';
		addNewInstanceMethod: 'totalCharge
			^totalCharge ifNil: [totalCharge := 0] ';
		addNewInstanceMethod: 'addCharge: aNumber
			totalCharge := self totalCharge + aNumber').
	self addClassModifier: (PhClassModifier new
		on: PhTelecomLocal;
		addNewInstanceMethod: 'callRate
			^', localChargeRate asString).
	self addClassModifier: (PhClassModifier new
		on: PhTelecomLongDistance;
		addNewInstanceMethod: 'callRate
			^', longDistanceChargeRate asString).   ! !

PhAspect subclass: #PhTelecomAspectTimerLog
	instanceVariableNames: ''
	classVariableNames: 'Asp'
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomAspectTimerLog methodsFor: 'initialization' stamp: 'DanielGaldames 4/6/2011 20:19'!
initialize
	| pcStart pcStop |
	super initialize.
	self add: (PhAdvice new
		pointcut: (PhPointcut new
			receivers: 'PhTelecomTimer';
			selectors: 'start';
			context: #(#receiver));
		advice: [:context | Transcript show: ('Timer started: ', (context receiver startTime asString)); cr.];
		type: #after).
	self add: (PhAdvice new
		pointcut: (PhPointcut new
			receivers: 'PhTelecomTimer';
			selectors: 'stop';
			context: #(#receiver));
		advice: [:context | Transcript show: ('Timer stoped: ', (context receiver stopTime asString)); cr.];
		type: #after).! !

PhAspect subclass: #PhTelecomAspectTiming
	instanceVariableNames: ''
	classVariableNames: 'Asp EndTimingPointcut'
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomAspectTiming classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:31'!
endTimingPointcut
	^EndTimingPointcut ifNil: [
		EndTimingPointcut := PhPointcut new
			receivers: 'PhTelecomConnection';
			selectors: 'drop';
			context: #(receiver)]  ! !

!PhTelecomAspectTiming methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/13/2011 22:54'!
initialize
	super initialize.
	self add: (PhAdvice new
		pointcut: (PhPointcut new
			receivers: 'PhTelecomConnection';
			selectors: 'complete';
			context: #(#receiver) );
		advice: [:context | context receiver timer start.];
		type: #after).
	self add: (PhAdvice new
		pointcut: (self class endTimingPointcut);
		advice: [:context |
			| conectionTime | 
			context receiver timer stop.
			conectionTime := context receiver timer getTime.  
			context receiver caller totalConnectTime: (conectionTime + (context receiver caller totalConnectTime)).
			context receiver receiver totalConnectTime: (conectionTime + (context receiver receiver totalConnectTime))];
		type: #after).
	self addClassModifier: (PhClassModifier new
		on: PhTelecomCustomer;
		addNewInstanceVar: 'totalConnectTime';
		addNewInstanceMethod: 'totalConnectTime
			^totalConnectTime ifNil: [totalConnectTime := 0]';
		addNewInstanceMethod: 'totalConnectTime: aNumber
			totalConnectTime := aNumber '  ).
	self addClassModifier: (PhClassModifier new
		on: PhTelecomConnection;
		addNewInstanceVar: 'timer';
		addNewInstanceMethod: 'timer
			^timer ifNil: [timer := PhTelecomTimer new] ')    ! !

PhAspect subclass: #TraceDemoAspect
	instanceVariableNames: ''
	classVariableNames: 'Trace'
	poolDictionaries: ''
	category: 'Phantom-Examples'!

!TraceDemoAspect methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:47'!
initialize
	| methodPc constructorPc |
	super initialize.
	Trace := PhantomDemoTrace.
	methodPc := PhPointcut new
		receivers: #('PhantomDemoTwoDShape' 'PhantomDemoSquare' 'PhantomDemoCircle');
		localSelectors: #any asParser star;
		context: #(#receiver #arguments #selector).
	  
	constructorPc := PhPointcut new
		receivers: #('PhantomDemoTwoDShape class' 'PhantomDemoSquare class' 'PhantomDemoCircle class');
		localSelectors: #any asParser star;
		context: #(#receiver #arguments #selector).
		
	self add: (PhAdvice new
		pointcut: methodPc;
		advice: [:context | Trace traceEntry: (context receiver class asString), ' ', (context selector asString)];
		type: #before).
	self add: (PhAdvice new
		pointcut: methodPc;
		advice: [:context | Trace traceExit: (context receiver class asString), ' ', (context selector asString)];
		type: #after).
	self add: (PhAdvice new
		pointcut: constructorPc;
		advice: [:context | Trace traceEntry: (context receiver class asString), ' ', (context selector asString)];
		type: #before).
	self add: (PhAdvice new
		pointcut: constructorPc;
		advice: [:context | Trace traceExit: (context receiver class asString), ' ', (context selector asString)];
		type: #after).
		! !

!TraceDemoAspect methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:26'!
trace
	^Trace! !

Object subclass: #PhTelecomAbstractSimulation
	instanceVariableNames: ''
	classVariableNames: 'Simulation'
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomAbstractSimulation methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 14:04'!
report: aCustomer
	self subclassResponsibility.! !

!PhTelecomAbstractSimulation methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 13:57'!
run
	| jim mik crista c1 c2 |
	jim := PhTelecomCustomer name: 'jim' areaCode: 650.
	mik := PhTelecomCustomer name: 'mik' areaCode: 650.
	crista := PhTelecomCustomer name: 'crista' areaCode: 415.
	self say: 'jim calls mik...'.
	c1 := jim call: mik.
	self wait: 1.
	self say: 'mik accepts...'.
	mik pickup: c1.
	self wait: 2.
	self say: 'jim hangs up...'.
	jim hangup: c1.
	self report: jim.
	self report: mik.
	self report: crista.
	
	self say: 'mik calls crista...'.
	c2 := mik call: crista.
	self say: 'crista accepts...'.
	crista pickup: c2.
	self wait: 1.5.
	self say: 'crista hangs up...'.
	crista hangup: c2.
	self report: jim.
	self report: mik.
	self report: crista.
	! !

!PhTelecomAbstractSimulation methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 14:34'!
say: aString
	Transcript show: aString; cr.! !

!PhTelecomAbstractSimulation methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 14:11'!
wait: seconds
	(Delay forSeconds: seconds) wait.! !

PhTelecomAbstractSimulation subclass: #PhTelecomBasicSimulation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomBasicSimulation classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 14:46'!
run
	Transcript open.
	self new run.! !

!PhTelecomBasicSimulation methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 17:59'!
report: aPhTelecomCustomer
! !

PhTelecomAbstractSimulation subclass: #PhTelecomBillingSimulation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomBillingSimulation classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/1/2011 22:28'!
run
	| timerLog timing billing membrane |
	[timerLog := PhTelecomAspectTimerLog new.
	timing := PhTelecomAspectTiming new.
	billing := PhTelecomAspectBilling new.
	membrane := PhMembrane new pointcut: (PhPointcut new
		receivers: #('PhTelecomCall' 'PhTelecomConnection+' 'PhTelecomCustomer' 'PhTelecomTimer');
		localSelectors: #any asParser).
	membrane install.  
	timerLog registerOn: membrane.  
	timing registerOn: membrane.
	billing registerOn: membrane.
	Transcript open.
	Transcript show: 'Billing simulation'; cr.
	self new run] ensure: [membrane uninstall]! !

!PhTelecomBillingSimulation methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/13/2011 22:58'!
report: aPhTelecomCustomer
	Transcript show: aPhTelecomCustomer asString,
		' has been conected for ', aPhTelecomCustomer totalConnectTime asString,
		' milliseconds and has a bill of ',
		aPhTelecomCustomer totalCharge asString.
	Transcript cr.! !

PhTelecomAbstractSimulation subclass: #PhTelecomTimingSimulation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomTimingSimulation classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/1/2011 22:53'!
run
	| timerLog timing membrane|
	[timerLog := PhTelecomAspectTimerLog new.
	timing := PhTelecomAspectTiming new.
	membrane := PhMembrane new pointcut: (PhPointcut new
		receivers: #('PhTelecomCall' 'PhTelecomConnection+' 'PhTelecomCustomer' 'PhTelecomTimer');
		localSelectors: #any asParser).
	membrane install.  
	timerLog registerOn: membrane.  
	timing registerOn: membrane.   
	Transcript open.
	Transcript show: 'Timing simulation'; cr.
	self new run] ensure: [membrane uninstall]! !

!PhTelecomTimingSimulation methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/13/2011 22:56'!
report: aPhTelecomCustomer
	Transcript show: (aPhTelecomCustomer asString, ' spent ', aPhTelecomCustomer totalConnectTime asString); cr.  ! !

Object subclass: #PhTelecomCall
	instanceVariableNames: 'caller receiver connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomCall classSide methodsFor: 'instance creation' stamp: 'DanielGaldames 4/6/2011 17:38'!
caller: caller receiver: receiver
	| call |
	call := (self new)
		caller: caller;
		receiver: receiver;
		yourself.
	(receiver localTo: caller)
		ifTrue: [call connections add: (PhTelecomLocal caller: caller receiver: receiver)]
		ifFalse: [call connections add: (PhTelecomLongDistance caller: caller receiver: receiver)].
	^call! !

!PhTelecomCall methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:17'!
caller: aPhTelecomCustomer 
	caller := aPhTelecomCustomer! !

!PhTelecomCall methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:50'!
connections
	^ connections! !

!PhTelecomCall methodsFor: 'calling' stamp: 'DanielGaldames 4/6/2011 17:57'!
hangup: aPhTelecomCustomer 
	connections do: [:each | each drop]! !

!PhTelecomCall methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/6/2011 17:29'!
initialize
	connections := OrderedCollection new.! !

!PhTelecomCall methodsFor: 'calling' stamp: 'DanielGaldames 4/6/2011 17:29'!
pickup
	(connections last) complete.! !

!PhTelecomCall methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:17'!
receiver: aPhTelecomCustomer 
	receiver := aPhTelecomCustomer! !

Object subclass: #PhTelecomConnection
	instanceVariableNames: 'caller receiver state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomConnection classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 17:42'!
caller: aCaller receiver: aReceiver
	^(self new)
		caller: aCaller;
		receiver: aReceiver;
		yourself.  ! !

!PhTelecomConnection methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:44'!
caller
	^ caller! !

!PhTelecomConnection methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:44'!
caller: anObject
	caller := anObject! !

!PhTelecomConnection methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 17:45'!
complete
	state := #complete.
	Transcript show: 'connection completed'; cr.! !

!PhTelecomConnection methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 17:47'!
connects: aPhCustomer
	^ ((caller = aPhCustomer) | (receiver = aPhCustomer))! !

!PhTelecomConnection methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 17:46'!
drop
	state := #droped.
	Transcript show: 'connection droped'; cr.! !

!PhTelecomConnection methodsFor: 'initialization' stamp: 'DanielGaldames 4/13/2011 22:52'!
initialize
	state := #pending.! !

!PhTelecomConnection methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:44'!
receiver
	^ receiver! !

!PhTelecomConnection methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:44'!
receiver: anObject
	receiver := anObject! !

!PhTelecomConnection methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:44'!
state
	^ state! !

!PhTelecomConnection methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:44'!
state: anObject
	state := anObject! !

PhTelecomConnection subclass: #PhTelecomLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomLocal classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 18:06'!
caller: caller receiver: receiver
	Transcript show: ('[new local connection from ', caller asString, ' to ', receiver asString, ']'); cr.
	^super caller: caller receiver: receiver! !

PhTelecomConnection subclass: #PhTelecomLongDistance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomLongDistance classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 18:07'!
caller: caller receiver: receiver
	Transcript show: ('[new long distance connection from ', caller asString, ' to ', receiver asString, ']'); cr.
	^super caller: caller receiver: receiver! !

Object subclass: #PhTelecomCustomer
	instanceVariableNames: 'name areaCode calls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomCustomer classSide methodsFor: 'instance creation' stamp: 'DanielGaldames 4/6/2011 14:49'!
name: aByteString areaCode: aSmallInteger 
	^(self new)
		customerName: aByteString;
		areaCode: aSmallInteger;
		yourself.! !

!PhTelecomCustomer methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:24'!
addCall: aPhTelecomCall 
	calls add: aPhTelecomCall! !

!PhTelecomCustomer methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:50'!
areaCode
	^ areaCode! !

!PhTelecomCustomer methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 14:49'!
areaCode: aSmallInteger 
	areaCode := aSmallInteger! !

!PhTelecomCustomer methodsFor: 'calling' stamp: 'DanielGaldames 4/6/2011 17:15'!
call: aPhTelecomCustomer 
	| call |
	call := PhTelecomCall caller: self receiver: aPhTelecomCustomer.
	self addCall: call.
	^call.! !

!PhTelecomCustomer methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 14:48'!
customerName: aByteString 
	name := aByteString! !

!PhTelecomCustomer methodsFor: 'calling' stamp: 'DanielGaldames 4/6/2011 17:56'!
hangup: aPhTelecomCall 
	aPhTelecomCall hangup: self.
	self removeCall: aPhTelecomCall.! !

!PhTelecomCustomer methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/13/2011 22:52'!
initialize
	calls := OrderedCollection new.
	totalCharge := 0.! !

!PhTelecomCustomer methodsFor: 'comparing' stamp: 'DanielGaldames 4/6/2011 17:50'!
localTo: aPhTelecomCustomer 
	^ (areaCode = aPhTelecomCustomer areaCode)! !

!PhTelecomCustomer methodsFor: 'calling' stamp: 'DanielGaldames 4/6/2011 17:27'!
pickup: aPhTelecomCall 
	aPhTelecomCall pickup.
	self addCall: aPhTelecomCall.    ! !

!PhTelecomCustomer methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 18:09'!
printOn: aStream
	aStream 
		nextPutAll: name, ' (', areaCode asString, ')'.! !

!PhTelecomCustomer methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 17:58'!
removeCall: aPhTelecomCall 
	calls remove: aPhTelecomCall! !

Object subclass: #PhTelecomTimer
	instanceVariableNames: 'startTime stopTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples-Telecom'!

!PhTelecomTimer methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 21:21'!
getTime
	^ (Time milliseconds: stopTime since: startTime)! !

!PhTelecomTimer methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 21:17'!
start
	startTime := Time millisecondClockValue.
	stopTime := startTime.! !

!PhTelecomTimer methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 20:11'!
startTime
	^ startTime! !

!PhTelecomTimer methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 20:11'!
startTime: anObject
	startTime := anObject! !

!PhTelecomTimer methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/6/2011 21:19'!
stop
	stopTime := Time millisecondClockValue.! !

!PhTelecomTimer methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 20:11'!
stopTime
	^ stopTime! !

!PhTelecomTimer methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 20:11'!
stopTime: anObject
	stopTime := anObject! !

Object subclass: #PhantomDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples'!

!PhantomDemo classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/1/2011 21:46'!
clonableComparableHashableExample
	| clonable hashable comparable membrane|
	[| p1 p2 dict |
	"Transcript open."
	clonable := ClonablePointDemoAspect new.
	hashable := HashablePointDemoAspect new.
	comparable := ComparablePointDemoAspect new.
	membrane := PhMembrane new pointcut: (PhPointcut new
		receivers: 'PhantomDemoPoint+';
		selectors: #('hash' '=' 'doesNotUnderstand:' 'postCopy')).
	membrane install.
	clonable registerOn: membrane.  
	hashable registerOn: membrane.  
	comparable registerOn: membrane.
	Transcript show: 'Clonable test'; cr.
	p1 := PhantomDemoPoint new.
	p1 setPolarWith: (Float pi) and: 1.0.
	p2 := p1 copy.
	Transcript show: 'p1: ', p1 asString; cr.
	Transcript show: 'p2: ', p2 asString; cr.
	p1 rotate: (Float pi / -2.0).
	Transcript show: 'p1: ', p1 asString; cr.
	Transcript show: 'p2: ', p2 asString; cr.
	Transcript show: 'Hashable test'; cr.
	p1 := PhantomDemoPoint new.
	p2 := PhantomDemoPoint new.
	p1 setRectangularWith: 10 and: 10.
	p2 setRectangularWith: 10 and: 10.
	dict := Dictionary newFrom: {p1 -> 'p1'}.
	Transcript show: 'p1: ', p1 asString; cr.
	Transcript show: 'p2: ', p2 asString; cr.
	Transcript show: 'p1: ', p1 hash asString; cr.
	Transcript show: 'p2: ', p2 hash asString; cr.
	Transcript show: ('Got: ', (dict at: p2) asString); cr.
	Transcript show: 'Comparable test'; cr.
	p1 := PhantomDemoPoint new.
	p2 := PhantomDemoPoint new.
	Transcript show: ('p1 =?= p2 : ', (p1 compareTo: p2) asString); cr.
	p1 setRectangularWith: 2 and: 5.
	p2 setRectangularWith: 2 and: 5.
	Transcript show: ('p1 =?= p2 : ', (p1 compareTo: p2) asString); cr.
	p2 setRectangularWith: 3 and: 6.
	Transcript show: ('p1 =?= p2 : ', (p1 compareTo: p2) asString); cr.
	 ] ensure: [
	membrane uninstall. ]! !

!PhantomDemo classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/1/2011 21:48'!
getInfoExample
	| pc adv asp membrane |
	"Transcript open."
	Transcript show: 'Demo without aspect installed'; cr; cr.
	PhantomDemoClass go.
	pc := PhPointcut new
	receivers: 'PhantomDemoClass';
	localSelectors: #any asParser star;
	context: #(#receiver #arguments #proceed #selector).
	membrane := PhMembrane new pointcut: pc.  
	adv := PhAdvice new
		pointcut: pc;
		type: #around;
		advice: [:context |
			| result |
			Transcript show: 'Intercepted message: ', context selector asString; cr.
			Transcript show: 'in: ', context receiver class name asString; cr.
			Transcript show: 'parameters: ', context arguments asString; cr.
			Transcript show: 'Running original method:'; cr.
			 result := context proceed.
			Transcript show: 'result: ', result asString; cr.
			result].

		asp := PhAspect new.
		asp add: adv.
		[membrane install.
		asp registerOn: membrane.  
		Transcript show: 'Demo with installed aspect'; cr;cr.
		PhantomDemoClass go.
		] ensure: [membrane uninstall]! !

!PhantomDemo classSide methodsFor: 'as yet unclassified' stamp: 'dgg 5/1/2011 22:00'!
traceExample1
	| c1 c2 s1 asp membrane |
	"Transcript open."
	PhantomDemoTrace tracelevel: 2.  
	PhantomDemoTrace initStream: (WriteStream on: '').  
	asp := TraceDemoAspect new.
	membrane := PhMembrane new pointcut: (PhPointcut new
		receivers: #('PhantomDemoTwoDShape+' 'PhantomDemoTwoDShape class+');
		localSelectors: #any asParser).  
	[membrane install.
	asp registerOn: membrane.  
	c1 := PhantomDemoCircle x: 3.0 y: 3.0 r: 2.0.
	c2 := PhantomDemoCircle r: 4.0.
	s1 := PhantomDemoSquare x: 1.0 y: 2.0.
	Transcript show: 'c1 perimeter : ', (c1 perimeter asString); cr.
	Transcript show: 'c1 area : ', (c1 area asString); cr.
	Transcript show: 's1 perimeter : ', (s1 perimeter asString); cr.
	Transcript show: 's1 area : ', (s1 area asString); cr.
	Transcript show: 'c2 distance c1 : ', ((c2 distance: c1) asString); cr.
	Transcript show: 's1 distance c1 : ', ((s1 distance: c1) asString); cr.
	Transcript show: 's1 asString : ', (s1 asString); cr.
	Transcript show: asp trace traceStream contents.] ensure: [membrane uninstall]  ! !

Object subclass: #PhantomDemoClass
	instanceVariableNames: ''
	classVariableNames: 'D'
	poolDictionaries: ''
	category: 'Phantom-Examples'!

!PhantomDemoClass classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:29'!
go
	D := self new.
	D foo: 1 object: D.
	Transcript show: (D bar: 3); cr.
		! !

!PhantomDemoClass methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 13:44'!
bar: aNumber
	Transcript show: ('Demo bar: ', aNumber asString); cr.
	^ 'Demo bar: ', aNumber asString! !

!PhantomDemoClass methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 13:44'!
foo: aNumber object: anObject
	Transcript show: ('Demo foo: ', aNumber asString, ' object: ', anObject asString); cr.! !

Object subclass: #PhantomDemoPoint
	instanceVariableNames: 'x y theta rho rectangular polar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples'!

!PhantomDemoPoint classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 16:18'!
main
	| p1 |
	p1 := self new.
	Transcript show: 'p1 = ', p1 asString; cr.
	p1 setRectangularWith: 5 and: 2.
	Transcript show: 'p1 = ', p1 asString; cr.
	p1 setPolarWith: (Float pi / 4.0) and: 1.0.
	Transcript show: 'p1 = ', p1 asString; cr.
	p1 setPolarWith: 0.3805 and: 5.385.
	Transcript show: 'p1 = ', p1 asString; cr.! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 16:15'!
initialize
	super initialize.
	x := 0.
	y := 0.
	theta := 0.
	rho := 0.
	polar := true.
	rectangular := true.! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 16:03'!
makePolar
	polar ifFalse: [
		theta := x arcTan: y.
		rho := y / (theta sin).
		polar := true.]  ! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 16:04'!
makeRectangular
	rectangular ifFalse: [
		x := rho * (theta sin).
		y := rho * (theta cos).
		rectangular := true]  ! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 15:58'!
offsetWith: deltaX and: deltaY
	self setRectangularWith: (x + deltaX) and: (y  + deltaY)   ! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 16:12'!
printOn: aStream
	aStream nextPutAll: '(', (self x asString), ', ', (self y asString), ')[', (self theta asString), ' : ', (self rho asString), ']'.   ! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 15:53'!
rho
	self makePolar.
	^rho! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 15:57'!
rotate: anAngle
	self setPolarWith: (theta + anAngle) and: rho.   ! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 15:56'!
setPolarWith: newTheta and: newRho
	theta := newTheta.
	rho := newRho.
	rectangular := false.
	polar := true.! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 15:55'!
setRectangularWith: newX and: newY
	x := newX.
	y := newY.
	rectangular := true.
	polar := false! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 15:52'!
theta
	self makePolar.
	^theta! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 15:51'!
x
	self makeRectangular.
	^x! !

!PhantomDemoPoint methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/1/2011 15:52'!
y
	self makeRectangular.
	^y! !

Object subclass: #PhantomDemoTrace
	instanceVariableNames: ''
	classVariableNames: 'CallDepth TraceLevel TraceStream'
	poolDictionaries: ''
	category: 'Phantom-Examples'!

!PhantomDemoTrace classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:28'!
initStream: aStream
	TraceStream := aStream.
	CallDepth := 0.! !

!PhantomDemoTrace classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:29'!
initialize
	TraceLevel := 0.
	CallDepth := 0.  ! !

!PhantomDemoTrace classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:28'!
printEntering: aString
	self printIdent.
	TraceStream nextPutAll: '--> ', aString.
	TraceStream nextPut: Character cr.      ! !

!PhantomDemoTrace classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:28'!
printExiting: aString
	self printIdent.
	TraceStream nextPutAll: '<-- ', aString.
	TraceStream nextPut: Character cr.      ! !

!PhantomDemoTrace classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:28'!
printIdent
	(CallDepth > 0) ifTrue: [(1 to: CallDepth) do: [:i | TraceStream nextPutAll: '	']]! !

!PhantomDemoTrace classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:29'!
traceEntry: aString
	(TraceLevel > 0) ifTrue: [
		(TraceLevel = 2) ifTrue: [CallDepth := CallDepth +1].
		self printEntering: aString]  ! !

!PhantomDemoTrace classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:29'!
traceExit: aString
	(TraceLevel > 0) ifTrue: [
		self printExiting: aString.
		(TraceLevel = 2) ifTrue: [CallDepth := CallDepth -1]]  ! !

!PhantomDemoTrace classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 18:28'!
traceStream
	^TraceStream! !

!PhantomDemoTrace classSide methodsFor: 'accessing' stamp: 'DanielGaldames 4/22/2011 18:29'!
tracelevel
	^ TraceLevel! !

!PhantomDemoTrace classSide methodsFor: 'accessing' stamp: 'DanielGaldames 4/22/2011 18:29'!
tracelevel: anObject
	TraceLevel := anObject! !

Object subclass: #PhantomDemoTwoDShape
	instanceVariableNames: 'x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples'!

PhantomDemoTwoDShape subclass: #PhantomDemoCircle
	instanceVariableNames: 'r'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples'!

!PhantomDemoCircle classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:10'!
new
	^self x: 0.0 y: 0.0 r: 1.0! !

!PhantomDemoCircle classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:10'!
r: radio
	^self x: 0.0 y: 0.0 r: radio! !

!PhantomDemoCircle classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:09'!
x: xcoord y: ycoord
	^self x: xcoord y: ycoord r: 1.0! !

!PhantomDemoCircle classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 14:58'!
x: xcoord y: ycoord r: radio
	^(super x: xcoord y: ycoord)
		r: radio;
		yourself! !

!PhantomDemoCircle methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:01'!
area
	^(Float pi * (r raisedTo: 2))! !

!PhantomDemoCircle methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:01'!
perimeter
	^(2 * Float pi * r)! !

!PhantomDemoCircle methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:03'!
printOn: aStream
	aStream
		nextPutAll: 'Circle radius = ';
		nextPutAll: r asString.
	super printOn: aStream.          ! !

!PhantomDemoCircle methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 14:56'!
r
	^ r! !

!PhantomDemoCircle methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 14:56'!
r: anObject
	r := anObject! !

PhantomDemoTwoDShape subclass: #PhantomDemoSquare
	instanceVariableNames: 's'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Examples'!

!PhantomDemoSquare classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:09'!
new
	^self x: 0.0 y: 0.0 s: 1.0! !

!PhantomDemoSquare classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:08'!
s: side
	^self x: 0.0 y: 0.0 s: side! !

!PhantomDemoSquare classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:08'!
x: xcoord y: ycoord
	^self x: xcoord y: ycoord s: 1.0! !

!PhantomDemoSquare classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:06'!
x: xcoord y: ycoord s: side
	^(super x: xcoord y: ycoord)
		s: side;
		yourself! !

!PhantomDemoSquare methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:14'!
area
	^ s raisedTo: 2.  ! !

!PhantomDemoSquare methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:14'!
perimeter
	^ 4 * s.! !

!PhantomDemoSquare methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:15'!
printOn: aStream
	aStream
		nextPutAll: 'Squeare side = ';
		nextPutAll: s asString.
	super printOn: aStream.        ! !

!PhantomDemoSquare methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 15:06'!
s
	^ s! !

!PhantomDemoSquare methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 15:06'!
s: anObject
	s := anObject! !

!PhantomDemoTwoDShape classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:13'!
x: xcoord y: ycoord
	^(super new)
		x: xcoord;
		y: ycoord; 
		yourself! !

!PhantomDemoTwoDShape methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 14:47'!
area
	self subclassResponsibility ! !

!PhantomDemoTwoDShape methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 17:07'!
distance: aTwoDShape
	| dx dy |
	dx := (aTwoDShape x - x) abs.
	dy := (aTwoDShape y - y) abs.
	^((dx raisedTo: 2) + (dy raisedTo: 2)) sqrt.! !

!PhantomDemoTwoDShape methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 14:47'!
perimeter
	self subclassResponsibility ! !

!PhantomDemoTwoDShape methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 15:03'!
printOn: aStream
	aStream
		nextPutAll: ' @ (';
		nextPutAll: x asString;
		nextPutAll: ', ';
		nextPutAll: y asString;
		nextPutAll: ') '        
	    ! !

!PhantomDemoTwoDShape methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 14:44'!
x
	^x! !

!PhantomDemoTwoDShape methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 14:53'!
x: anObject
	x := anObject! !

!PhantomDemoTwoDShape methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/3/2011 14:44'!
y
	^y! !

!PhantomDemoTwoDShape methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 14:53'!
y: anObject
	y := anObject! !
PhantomDemoTrace initialize!
